
package de.ivu.elect.business.datei.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.datei.entity.DateiExport;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractDateiExportEdit {

  @Inject
  protected DateiExportDAO dao;

  @Inject
  protected DateiExportExtendedDAO extendedDao;

  public void delete(DateiExport entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(DateiExport entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(DateiExport entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected DateiExport getAttachedEntity(DateiExport entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected DateiExport getAttachedAndRefreshedEntity(DateiExport entity) {
    return dao.refresh(entity);
  }
}
